﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FlexGrid_DragDrop
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            #region 初始化 Spread 对象

            fpSpread1.AllowDrop = true;
            fpSpread1.ActiveSheet.ColumnCount = 2;
            fpSpread1.ActiveSheet.Columns[0, 1].Width = 200;
            fpSpread1.DragEnter += new DragEventHandler(fpSpread1_DragEnter);
            fpSpread1.DragDrop += new DragEventHandler(fpSpread1_DragDrop);

            #endregion

            #region 初始化FlexGrid

            // 使用用户自定义的拖拽方式
            c1FlexGrid1.DragMode = C1.Win.C1FlexGrid.DragModeEnum.Manual;

            c1FlexGrid1.Cols.Fixed = 0;
            c1FlexGrid1.Rows.Count = 1;
            c1FlexGrid1.Cols.Count = 1;
            c1FlexGrid1.ExtendLastCol = true;
            c1FlexGrid1.Styles.Normal.TextAlign = C1.Win.C1FlexGrid.TextAlignEnum.LeftCenter;
            c1FlexGrid1.Styles.Normal.Border.Style = C1.Win.C1FlexGrid.BorderStyleEnum.None;

            c1FlexGrid1.Tree.Column = 0;
            c1FlexGrid1.Tree.Style = C1.Win.C1FlexGrid.TreeStyleFlags.SimpleLeaf;
            c1FlexGrid1.Tree.LineColor = Color.DarkBlue;

            c1FlexGrid1.MouseDown += new MouseEventHandler(c1FlexGrid1_MouseDown);

            BuildTree();

            #endregion

            c1FlexGrid1.Styles[C1.Win.C1FlexGrid.CellStyleEnum.EmptyArea].Border.Style = C1.Win.C1FlexGrid.BorderStyleEnum.None;
            c1FlexGrid1.Styles[C1.Win.C1FlexGrid.CellStyleEnum.EmptyArea].BackColor = Color.White;

            c1FlexGrid1.MouseMove += new MouseEventHandler(c1FlexGrid1_MouseMove);
        }

    int oldrow = -1;
    int oldcolumn = -1;
    private string _tip =
        @"<table><tr>
            <td><parm><img src='res://c1-logo.png'></parm>
            <td><b><parm>SuperTooltip 功能展示</parm></b>
        </table>
        <parm><hr noshade size=1 style='margin:2' color=Darker></parm>
        <div style='margin:1 12'><parm>
            当前单元格坐标： X={0}  Y={1}<br>
            当前单元格数据：{2}<br>            
        </parm></div>
        <parm><hr noshade size=1 style='margin:2' color=Darker></parm>
        <table><tr>
            <td><parm></parm>
            <td><b><parm>你还可以设置更丰富的显示内容！</parm></b>
        </table>";
    void c1FlexGrid1_MouseMove(object sender, MouseEventArgs e)
    {
        // 获取当前鼠标所在单元格信息
        C1.Win.C1FlexGrid.HitTestInfo hti = c1FlexGrid1.HitTest(e.X, e.Y);

        // 判断鼠标当前位置是否和上一位置有变化
        if (hti.Row == oldrow && hti.Column == oldcolumn)
        {
            return;
        }
        else
        {
            oldrow = hti.Row;
            oldcolumn = hti.Column;
        }

        // 设置 C1Flexgrid 的 ToolTip
        if ((hti.Row != -1 && hti.Column != -1) && (c1FlexGrid1[hti.Row, hti.Column] != null))
        {
            //toolTip1.SetToolTip(c1FlexGrid1, c1FlexGrid1[hti.Row, hti.Column].ToString() + " + 你想要显示的内容。");
            c1SuperTooltip1.SetToolTip(c1FlexGrid1, string.Format(_tip,hti.Row,hti.Column,c1FlexGrid1[hti.Row,hti.Column].ToString()));
        }
        else
        {
            //toolTip1.SetToolTip(c1FlexGrid1, "");
            c1SuperTooltip1.SetToolTip(c1FlexGrid1, "");
        }

    }

        void fpSpread1_DragDrop(object sender, DragEventArgs e)
        {
            // 将拖拽到 Spread 上数据填写到相应的单元中
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                Point point = fpSpread1.PointToClient(Control.MousePosition);
                FarPoint.Win.Spread.HitTestInformation hi = fpSpread1.HitTest(point.X, point.Y);

                if (hi.ViewportInfo.Column == 0)
                {
                    fpSpread1.ActiveSheet.Cells[hi.ViewportInfo.Row, hi.ViewportInfo.Column].Value = e.Data.GetData(DataFormats.Text);
                }
            }
        }

        void fpSpread1_DragEnter(object sender, DragEventArgs e)
        {
            // 判断拖拽到 Spread 中数据的格式
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        void c1FlexGrid1_MouseDown(object sender, MouseEventArgs e)
        {
            // 选中一个单元格之后，开启拖拽功能
            C1.Win.C1FlexGrid.C1FlexGrid flex = sender as C1.Win.C1FlexGrid.C1FlexGrid;
            C1.Win.C1FlexGrid.HitTestInfo hti = flex.HitTest(e.X, e.Y);

            if (hti.Type == C1.Win.C1FlexGrid.HitTestTypeEnum.Cell && hti.Row < flex.Rows.Count - 1)
            {
                flex.DoDragDrop(flex[hti.Row, 0].ToString(), DragDropEffects.Copy);
            }
        }

        private void BuildTree()
        {
            C1.Win.C1FlexGrid.CellStyle cs = c1FlexGrid1.Styles.Add("Node");
            cs.Font = new System.Drawing.Font("微软雅黑", 10);
            cs.ForeColor = Color.DarkBlue;

            c1FlexGrid1.AddItem("西安葡萄城控件");
            C1.Win.C1FlexGrid.Row row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];

            C1.Win.C1FlexGrid.Node nd = row.Node;
            nd.Level = 0;
            nd.Image = Image.FromFile("1.png");
            c1FlexGrid1.AddItem("产品部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 产品部");
            c1FlexGrid1.AddItem("Spread 产品部");
            c1FlexGrid1.AddItem("ActiveReports 产品部");
            c1FlexGrid1.AddItem("TX TextControl 产品部");

            c1FlexGrid1.AddItem("市场部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 市场部");
            c1FlexGrid1.AddItem("Spread 市场部");
            c1FlexGrid1.AddItem("ActiveReports 市场部");
            c1FlexGrid1.AddItem("TX TextControl 市场部");

            c1FlexGrid1.AddItem("销售部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 销售部");
            c1FlexGrid1.AddItem("Spread 销售部");
            c1FlexGrid1.AddItem("ActiveReports 销售部");
            c1FlexGrid1.AddItem("TX TextControl 销售部");

            c1FlexGrid1.AddItem("服务部");
            row = c1FlexGrid1.Rows[c1FlexGrid1.Rows.Count - 1];
            row.IsNode = true;
            row.Style = c1FlexGrid1.Styles["Node"];
            nd = row.Node;
            nd.Level = 1;
            nd.Image = Image.FromFile("2.png");

            c1FlexGrid1.AddItem("ComponentOne 服务部");
            c1FlexGrid1.AddItem("Spread 服务部");
            c1FlexGrid1.AddItem("ActiveReports 服务部");
            c1FlexGrid1.AddItem("TX TextControl 服务部");
        }
    }
}
